:- dynamic (xtype)/1.

xtype[name:boolean, base:numeric, length:1, scale:0, desc:boolean, domain:[0, 1]].
xtype[name:integer, base:numeric, length:9, scale:0, desc:integer, domain:[-999999999 to 999999999]].
xtype[name:day, base:symbolic, domain:[mon/1, tue/2, wed/3, thu/4, fri/5, sat/6, sun/7], ordered:yes].
xtype[name:hour, base:numeric, domain:[0 to 23]].
xtype[name:month, base:numeric, domain:[1 to 12]].
xtype[name:operation, base:symbolic, domain:[bizhrs, nbizhrs], ordered:yes].
xtype[name:season, base:symbolic, domain:[spring, summer, fall, winter], ordered:yes].
xtype[name:thermostat_settings, base:numeric, domain:[14, 15, 16, 18, 20, 24, 27]].
xtype[name:today, base:symbolic, domain:[workday, weekend], ordered:yes].

:- dynamic (xtpgr)/1.


:- dynamic (xattr)/1.

xattr[name:day, abbrev:day, class:simple, type:day, comm: (in), callback:[ask_console, [day]]].
xattr[name:hour, abbrev:hour, class:simple, type:hour, comm: (in), callback:[ask_console, [hour]]].
xattr[name:month, abbrev:month, class:simple, type:month, comm: (in), callback:[ask_console, [month]]].
xattr[name:operation, abbrev:oper, class:simple, type:operation, comm:inter].
xattr[name:season, abbrev:seaso, class:simple, type:season, comm:inter].
xattr[name:thermostat_settings, abbrev:tset, class:simple, type:thermostat_settings, comm:out, callback:[tell_console, [thermostat_settings]]].
xattr[name:today, abbrev:today, class:simple, type:today, comm:inter].

:- dynamic (xatgr)/1.


:- dynamic (xschm)/1.

xschm ms:[month]==>[season].
xschm dt:[day]==>[today].
xschm th:[today, hour]==>[operation].
xschm os:[operation, season]==>[thermostat_settings].

:- dynamic (xrule)/1.

xrule ms/1:[month in [1, 2, 12]]==>[season set winter]:os/5.
xrule ms/2:[month in [3, 4, 5]]==>[season set spring]:os/3.
xrule ms/3:[month in [6, 7, 8]]==>[season set summer]:os/1.
xrule ms/4:[month in [9, 10, 11]]==>[season set fall]:os/7.
xrule dt/1:[day in [mon to fri]]==>[today set workday]:th/1.
xrule dt/2:[day in [sat, sun]]==>[today set weekend]:th/1.
xrule th/1:[today eq workday, hour gt 17]==>[operation set nbizhrs]:os/1.
xrule th/2:[today eq weekend, hour eq 20]==>[operation set nbizhrs]:os/1.
xrule th/3:[today eq workday, hour lt 9]==>[operation set nbizhrs]:os/1.
xrule th/4:[today eq workday, hour in [9 to 17]]==>[operation set bizhrs]:os/1.
xrule th/5:[today eq weekend, hour eq any]==>[operation set not_during_business_hours].
xrule os/1:[operation eq nbizhrs, season eq summer]==>[thermostat_settings set 27].
xrule os/2:[operation eq bizhrs, season eq summer]==>[thermostat_settings set 24].
xrule os/3:[operation eq nbizhrs, season eq spring]==>[thermostat_settings set 15].
xrule os/4:[operation eq bizhrs, season eq spring]==>[thermostat_settings set 20].
xrule os/5:[operation eq bizhrs, season eq winter]==>[thermostat_settings set 18].
xrule os/6:[operation eq nbizhrs, season eq winter]==>[thermostat_settings set 14].
xrule os/7:[operation eq nbizhrs, season eq fall]==>[thermostat_settings set 16].
xrule os/8:[operation eq bizhrs, season eq fall]==>[thermostat_settings set 20].

:- dynamic (xstat)/1.

xstat init:[month, 2].
xstat init:[day, wed].
xstat init:[hour, 3].
xstat current:[month, 2].
xstat current:[day, wed].
xstat current:[hour, 3].
xstat s1:[month, 2].
xstat s1:[day, wed].
xstat s1:[hour, 3].
xstat current:[today, workday].
xstat s2:[month, 2].
xstat s2:[day, wed].
xstat s2:[hour, 3].
xstat s2:[today, workday].
xstat current:[season, winter].
xstat s3:[month, 2].
xstat s3:[day, wed].
xstat s3:[hour, 3].
xstat s3:[today, workday].
xstat s3:[season, winter].
xstat current:[operation, nbizhrs].
xstat s4:[month, 2].
xstat s4:[day, wed].
xstat s4:[hour, 3].
xstat s4:[today, workday].
xstat s4:[season, winter].
xstat s4:[operation, nbizhrs].
xstat current:[thermostat_settings, 14].
xstat s5:[month, 2].
xstat s5:[day, wed].
xstat s5:[hour, 3].
xstat s5:[today, workday].
xstat s5:[season, winter].
xstat s5:[operation, nbizhrs].
xstat s5:[thermostat_settings, 14].

:- dynamic (xhalv)/1.


:- dynamic (xtraj)/1.

xtraj t1:[[start, s1], [dt/1, s2], [ms/1, s3], [th/3, s4], [os/6, s5]].

