:- arithmetic_function(scale). 


vget_covered_states(Schema,Att,FinalStates) :-
	alsv_attr_class(Att,simple),
	alsv_normalized_domain(Att,Domain, _),
	findall(S, (xrule Schema/_: F==>_,
        findall(InterState,(
   		   ((member(Att in RawInterState,F),RawInterState \= any, RawInterState \= [any],normalize(Att,RawInterState,InterState));
		   ((member(Att in any,F);member(Att in [any],F)),InterState=Domain);
		   (member(Att eq RawInterState,F),RawInterState \= any,normalize(Att,RawInterState,InterState));
		   (member(Att eq any,F),InterState=Domain);
		   (member(Att neq RawNeqInterState,F),RawNeqInterState \= any,normalize(Att,RawNeqInterState,NeqInterState),
		     alsv_except(Domain,[NeqInterState],InterState));
		   (member(Att notin RawInterState,F),normalize(Att,RawInterState,InterState));
		   (member(Att lt SD,F),normalize(Att,SD,NSD),vminimum(Domain,L),U is NSD-1,InterState=(L to U), L < U);
		   (member(Att gt SD,F),normalize(Att,SD,NSD),vmaximum(Domain,U),L is NSD+1,InterState=(L to U), L < U);
		   (member(Att lte SD,F),normalize(Att,SD,NSD),vminimum(Domain,L),InterState=(L to NSD));
		   (member(Att gte SD,F),normalize(Att,SD,NSD),vmaximum(Domain,U),InterState=(NSD to U)))),
        InterStates),
      %  flatten(InterStates,FlatInterStates),
        alsv_intersect_all(InterStates, S)
	),
	States),
	flatten(States,DupStates), 
	list_to_set(DupStates,FinalStates),!.

vget_covered_states(Schema,Att,FinalStates) :-
	alsv_attr_class(Att,general),
	alsv_normalized_domain(Att,Domain, _),
	findall(S, (xrule Schema/_: F==>_,
        findall(InterState,(
		   ((member(Att eq RawInterState,F),RawInterState \= any, RawInterState \=[any],normalize(Att,RawInterState,InterState));
		   ((member(Att eq any,F);member(Att eq [any],F)),InterState=Domain);
		   (member(Att neq RawNeqInterState,F),RawNeqInterState \= any,normalize(Att,RawNeqInterState,NeqInterState),
		     alsv_except(Domain,[NeqInterState],InterState));
		   (member(Att subseteq RawInterState,F),normalize(Att,RawInterState,InterState));
		   (member(Att supseteq RawInterState,F),normalize(Att,RawInterState,InterState));
		   (member(Att sim RawInterState,F),normalize(Att,RawInterState,InterState));
		   (member(Att notsim RawInterState,F),normalize(Att,RawInterState,InterState)))),
        InterStates),
       % flatten(InterStates,FlatInterStates),
        alsv_intersect_all(InterStates, S)
	),
	States),
	flatten(States,DupStates),
	list_to_set(DupStates,FinalStates),!.


vget_rules_states(Schema, FinalStates) :-
  findall([ID,Cond],(xrule Schema/ID: Cond ==> _),Conds),
  vget_rules_states_helper(Conds, FinalStates).


vget_rules_states_helper([],[]).
vget_rules_states_helper([[ID,C]|Conds], [[ID,RuleState]|States]) :-
  findall([Att,S],(
  		alsv_attr_class(Att,simple),
        alsv_normalized_domain(Att,Domain,_),
        findall(InterState,(
   		   ((member(Att in RawInterState,C),RawInterState \= any, RawInterState \= [any],normalize(Att,RawInterState,InterState));
		   ((member(Att in any,C);member(Att in [any],C)),InterState=Domain);
		   (member(Att eq RawInterState,C),RawInterState \= any,normalize(Att,RawInterState,InterState));
		   (member(Att neq RawNeqInterState,C),RawNeqInterState \= any,normalize(Att,RawNeqInterState,NeqInterState),
		     alsv_except(Domain,[NeqInterState],InterState));
		   (member(Att eq any,C),InterState=Domain);
		   (member(Att notin InterState,C),normalize(Att,RawInterState,InterState));
		   (member(Att lt SD,C),normalize(Att,SD,NSD),vminimum(Domain,L),U is NSD-1,InterState=(L to U), L < U);
		   (member(Att gt SD,C),normalize(Att,SD,NSD),vmaximum(Domain,U),L is NSD+1,InterState=(L to U), L < U);
		   (member(Att lte SD,C),normalize(Att,SD,NSD),vminimum(Domain,L),InterState=(L to NSD));
		   (member(Att gte SD,C),normalize(Att,SD,NSD),vmaximum(Domain,U),InterState=(NSD to U)))),
        InterStates), 
       % flatten(InterStates,FlatInterStates),
        alsv_intersect_all(InterStates, S)
	),
        RuleState),!,
	vget_rules_states_helper(Conds,States).

vget_rules_states_helper([[ID,C]|Conds], [[ID,RuleState]|States]) :-
  findall([Att,S],(		
  		alsv_attr_class(Att,general),
		alsv_normalized_domain(Att,Domain,_),
        findall(InterState,(
		   ((member(Att eq RawInterState,C),RawInterState \= any, RawInterState \=[any],normalize(Att,RawInterState,InterState));
		   ((member(Att eq any,C);member(Att eq [any],C)),InterState=Domain);
		   (member(Att neq RawNeqInterState,C),RawNeqInterState \= any,normalize(Att,RawNeqInterState,NeqInterState),
		     alsv_except(Domain,[NeqInterState],InterState));
		   (member(Att subseteq RawInterState,C),normalize(Att,RawInterState,InterState));
		   (member(Att supseteq RawInterState,C),normalize(Att,RawInterState,InterState));
		   (member(Att sim RawInterState,C),normalize(Att,RawInterState,InterState));
		   (member(Att notsim RawInterState,C),normalize(Att,RawInterState,InterState)))),
        InterStates),
        %flatten(InterStates,FlatInterStates),
        alsv_intersect_all(InterStates, S)
	),
        RuleState),!,
	vget_rules_states_helper(Conds,States).
        

vget_rules_decisions(Schema,FinalDecisions) :-
  findall([ID,Dec],(xrule Schema/ID: _ ==> Dec),Decs),
  vget_rules_decisions_helper(Decs, FinalDecisions).

vget_rules_decisions_helper([],[]).
vget_rules_decisions_helper([[ID,Dec]|Decs], [[ID,FinDec]|FinalDecisions]) :-
  findall([Att,State],member(Att set State, Dec),FinDec),
  vget_rules_decisions_helper(Decs,FinalDecisions).

scale(Scale) :- 
  precision(Precision),
  Scale is 10^Precision.

scale_down([],[]).
scale_down([[Att,Val]|States],[[Att,ScaledDownVal]|ScaledStates]) :-
  alsv_domain(Att,_,numeric),
  number(Val),
  ScaledDownVal is Val/scale,
  scale_down(States,ScaledStates).

scale_down([[Att,[Lower to Upper]]|States],[[Att,[SLower to SUpper]]|ScaledStates]) :-
  alsv_domain(Att,_,numeric),
  ((abs(Upper) < abs(inf),SUpper is Upper/scale),!;SUpper = inf),
  ((abs(Lower) < abs(inf),SLower is Lower/scale),!;SLower = -inf),
  scale_down(States,ScaledStates).

scale_down([[Att,Val]|States],[[Att,ScaledDownVal]|ScaledStates]) :-
  alsv_domain(Att,_,numeric),
  is_list(Val),
  findall(ScaledVal, (member(V,Val),number(V),ScaledVal is V/scale),ScaledDownVal),
  scale_down(States,ScaledStates).

scale_down([[Att,Val]|States],[[Att,Val]|ScaledStates]) :-
  scale_down(States,ScaledStates).

vmaximum([],end):-!.

vmaximum([_ to U|Set], InnerMaximum) :-
	vmaximum(Set,InnerMaximum),
	InnerMaximum\=end,
	InnerMaximum > U,!.

vmaximum([_ to U|_], U):-!.
	
vmaximum([H|Set], InnerMaximum) :-
	vmaximum(Set,InnerMaximum),
	InnerMaximum\=end,
	InnerMaximum > H,!.

vmaximum([H|_], H) :- !.	 

vminimum([],end):-!.

vminimum([L to _|Set], InnerMinimum) :-
	vminimum(Set,InnerMinimum),
	InnerMinimum\=end,
	InnerMinimum < L,!.

vminimum([L to _|_], L) :- !.
	
vminimum([H|Set], InnerMinimum) :-
	vminimum(Set,InnerMinimum),
	InnerMinimum\=end,
	InnerMinimum < H,!.

vminimum([H|_], H) :- !.	 

split_decision(D**>A:T/R,[D,A,T,R]) :- !.
split_decision(D**>A:T,[D,A,T,vnone]) :- !.
split_decision(D**>A,[D,A,vnone,vnone]) :- !.
split_decision(D:T/R,[D,[],T,R]) :- !.
split_decision(D:T,[D,[],T,vnone]) :- !.
split_decision(D,[D,[],vnone,vnone]) :- !.

invalid(Attr set Value) :- 
  alsv_attr_class(Attr,simple),
  v(Attr set Value2), 
  Value \= Value2, !.

invalid(Attr set VSet) :- 
  alsv_attr_class(Attr,general),
  v(Attr set WSet), 
  neqset(VSet,WSet), !.
  
  
vreport(N,D) :-
	flag_vreport(L),
	vid(ID),
	assert(xhalv(ID: D)),
	N =< L,
	vreport_process(D),!.
vreport(_,_).

vreport(N,D,File) :-
	flag_vreport(L),
	vid(ID),
	assert(xhalv(ID: D)),
	N =< L,
    append(File),
	vreport_process(D),!,
    told.
vreport(_,_,_).

vreport_process([]) :- nl,!.
vreport_process([H|T]):-
	write(H), write(' '),!,
	vreport_process(T).

	
get_current_vreport(VReport) :-
	vid(ID),
	findall(R,xhalv(ID:R),VReport),!.

get_current_vreport([]).

	
vgenid(ID) :-
	vid(ID),
	\+xhalv(ID : _),!.
	
vgenid(_) :-
	repeat,
	gensym(v,IDCandidate),
	retractall(vid(_)),
	assert(vid(IDCandidate)),
	\+xhalv(IDCandidate: _),!.

vconcat([String],String) :- !.
vconcat([E1,E2|List], String) :- atom_concat(E1,E2,Elem), vconcat([Elem|List], String).

vconcat_ws(_, [String], String) :- !.
vconcat_ws(Separator, [E1,E2|List], String):- vconcat([E1,Separator,E2], Elem),vconcat_ws(Separator,[Elem|List], String).


